/*
 * Archivo: problema2.cpp
 * Autor: Mariano Benito <mbenitohoz@gmail.com>
 * Fecha: 13/03/2012
 * Nota: No usar punteros.
 */

#include <iostream>
#include <cstdlib>
#include <map>
using namespace std;

/*
 * Calcula y almacena el factorial de los mil primeros numeros
 * y despues pregunta al usuario un numero entre 1 y 15 para
 * devolver por pantalla el factorial de ese numero.
 */
int main(void)
{
	int numero;
	map<int,int> factoriales;
	factoriales[1]=1;
	for(int i=2; i <= 15; i++)
		factoriales[i] = factoriales[i-1]*i;
	
	cout << "Introduzca un numero entre 1 y 15 para obtener su factorial: ";
	cin >> numero;
	if ( numero < 1 || numero > 15 )
	{
		cout<< "El numero introducido no cumple lo solicitado"<<"\n";
		return EXIT_FAILURE;
	}
	cout << "El factorial de "<< numero << " es " << factoriales[numero] <<"\n";
	return EXIT_SUCCESS;
}
