/*
 * Archivo: problema3.cpp
 * Autor: Mariano Benito <mbenitohoz@gmail.com>
 * Fecha: 19/03/2012
 */

#include <iostream>
#include <cstdlib>
#include <map>
using namespace std;

class punto3d{
public:
	int x;
	int y;
	int z;
};

/*
 * Genera un puntero y un punto con coordenadas 3,1,3.
 * Copiar la dirección de memoria del punto al puntero.
 * Imprimir el resultado por pantalla.
 * ¿Qué pasa si cambias el valor del punto?
 * ¿Cambia el contenido del puntero?
 */
int main(void)
{
	// Declarar un puntero.
	punto3d *puntero;
	// Crear el puntero y asignarle valores
	punto3d *punto;
	punto = new punto3d;
	(*punto).x = 3;
	(*punto).y = 1;
	(*punto).z =  3;

	puntero = punto;

	cout<<"Punto: ("<<(*punto).x<<","<<(*punto).y<<","<<(*punto).z<<")"<<endl;
	cout<<"Puntero: ("<<(*puntero).x<<","<<(*puntero).y<<","<<(*puntero).z<<")"<<endl;
	cout<<"Cambiamos el valor del punto.y a 2"<<endl;
	(*punto).y=2;
	cout<<"Punto: ("<<(*punto).x<<","<<(*punto).y<<","<<(*punto).z<<")"<<endl;
        cout<<"Puntero: ("<<(*puntero).x<<","<<(*puntero).y<<","<<(*puntero).z<<")"<<endl;
	// Respuesta: Al cambiar el valor de punto, también cambia el valor de todos los
	// punteros que apunten a el, en este caso puntero muestra lo mismo que punto.
	cout<<"Al cambiar el valor del punto, también cambia el valor de todos los punteros que apunten a el."<<endl;
	// Solo se libera una vez porque es la misma dirección.
	delete punto;

	return EXIT_SUCCESS;
}
